BMO-MKA
=======


Template consists of declaration in mka.ini file and actual template file.
The declaration consists of main section *mka.template.NAME* and optional
data section *mka.template.NAME.data*, where NAME is the templare name.
Following keys are valid in the main declaration:

 *  *file* (mandatory).  Specifies path to the Jinja2 template file
    relative to subdirectory *mka/templates*  under bmo config location
    (typically *~/.config/bmo*).

 *  *format* is a simple format string that is converted into actual
    filename by replacing each `%s` with argument *ARG* as specified on
    the command line.

The data section can contain any number of key and value pairs.
These will be made available to the Jinja2 template under global object
`data` and can be overriden on command line using option `--override`.

The template environment set up by bmo-mka contains four objects:

 *  *data* - holds template-specific values specified in config or on
    command line.

 *  *meta* - holds data about bmo-mka itself and details from generation
    time.  Currently contains:

     *  *meta.host* - hostname of the machine where the text was generated,

     *  *meta.date* - date of generation,

     *  *meta.version* - version of bmo

     *  *meta.url* - bmo project URL.

 *  *env* - a function accepting single argument of environment variable
    name and returning value of the variable or empty string if such
    variable is not defined.

 *  *file* - a function accepting single argument of path to a text
    file and returning its contents or empty string if the file cannot
    be read.

Read [official Jinja2 documentation][1] for details on how to write
templates:

  [1]: http://jinja.pocoo.org/docs/2.9/templates"


Example
-------

Example declaration may look like this:

    [mka.template.foo]
        file = foo.txt
        format = foo-%s.txt

    [mka.template.foo.data]
        bar = baz

The above example should be also accompanied with the template file in
*~/.config/bmo/mka/templates/foo.txt*.  A valid template could look
like this:

    Hello, this has been generated by {{env('USER')}}.
    Value of bar was '{{bar}}'

Following command can be then executed:

    $ bmo mka foo one
    /home/joe/out/foo-one.txt
    $ cat /home/joe/out/foo-one.txt
    Hello, this has been generated by joe.
    Value of bar was 'baz'
    $ cat `bmo mka -o bar=quux foo two`
    Hello, this has been generated by joe.
    Value of bar was 'quux'
    $

Notice that for given template, calling *bmo-mka* with same argument
(above illustrated by "one" and "two" above) results in same file path.
This to enable working on the file continuously without need to remember
the path. At the same time this forces you to use strict naming and
location convention for draft files.

Typical workflow could be:

    $ vim `bmo mka bug random-segfault`
    # ... work on the report, save it
    # then work on something else
    $ vim `bmo mka bug random-segfault`
    # ... finish the report
    $ mail -s "bug report" -t bugs@example.com <`bmo mka bug random-segfault`
    $ rm `bmo mka bug random-segfault`
